<template>
  <div class="language-select fixed inset-0 touch-none" @wheel.prevent.stop @click="closeModal">
    <div class="flex h-full items-center justify-center">
      <div
        class="language-select__content animated-modal p-8 pb-12 xs:p-4 xs:pb-8 bg-bgdsec rounded-32 xs:rounded-b-none xs:rounded-t-32 xs:fixed bottom-0 left-0 xs:w-full"
        @click.stop
      >
        <div class="flex items-center justify-between">
          <p class="text-txtdprim font-bold text-2xl leading-7 xs:text-lg xs:leading-6">Language</p>
          <UiButton color-type="secondary" button-height="sm" class="w-12 rounded-16" @click="closeModal">
            <img width="24" height="24" src="@/assets/images/ui/ui-cross.svg" />
          </UiButton>
        </div>
        <div class="mt-8">
          <div
            v-for="lang in languages"
            :key="lang.key"
            class="mt-2 hover:text-txtlprim dark:hover:text-txtdprim rounded-16 h-12 px-2 text-sm font-medium flex items-center gap-3 cursor-pointer"
            :class="
              lang.key === currentLanguage.key
                ? 'text-txtlprim dark:text-txtdprim bg-btnlsec dark:bg-btndsec'
                : 'text-txtlsec dark:text-txtdsec '
            "
            @click="handleLangClick(lang)"
            @mousedown.prevent
          >
            <img width="24" height="24" :src="require(`@/assets/images/flags/${lang.key}.svg`)" />
            <p class="flex-1">{{ lang.title }}</p>
            <img
              v-show="lang.key === currentLanguage.key"
              width="24"
              height="24"
              src="@/assets/images/ui/ui-check.svg"
            />
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import Cookies from 'js-cookie';
import UiButton from '@/components/ui/UiButton';

export default {
  name: 'LanguageSelect',

  components: { UiButton },

  data() {
    return {
      languages: [
        {
          key: 'en',
          title: 'English',
        },
        {
          key: 'cn',
          title: 'Chinese',
        },
      ],

      currentLanguage: {
        key: 'en',
        title: 'English',
      },
    };
  },

  mounted() {
    this.checkCookies()
  },

  methods: {
    closeModal() {
      this.$store.commit('setLanguageSelectDisplay', false);
    },

    handleLangClick(lang) {
      this.currentLanguage = lang;
      Cookies.set('flashLang', lang.key);
      this.$i18n.locale = lang.key;
    },

    checkCookies() {
      const lang = Cookies.get('flashLang');
      if (lang) {
        this.$i18n.locale = lang;
        this.currentLanguage = this.languages.find((_lang) => _lang.key === lang);
      }
    },
  },
};
</script>

<style lang="scss">
.language-select {
  background: rgba(12, 21, 33, 0.64);

  &__content {
    width: 500px;
  }
}
</style>
